int numbRuns = 40; //Number of runs
int relayFan = 19; //Setting the pin of the fan
int relaySol = 13; //Setting the pin of the solenoid valve
int hitLength = 5000; //Length of puff in milliseconds
long restTime = 535000; //Length of time to wait after puff in milliseconds


#define CPU_RESTART_ADDR (uint32_t *)0xE000ED0C
#define CPU_RESTART_VAL 0x5FA0004
#define CPU_RESTART (*CPU_RESTART_ADDR = CPU_RESTART_VAL);



bool flag1 = false;
bool flag2 = false;
bool flag3 = false;
bool flag4 = false;



void setup()
{
  Serial.begin(9600);
  pinMode(relaySol, OUTPUT); //Sets pin mode to output
  pinMode(relayFan, OUTPUT);
}


void loop()
{
    if (Serial.available()) {
    String myString = Serial.readString();
    if (myString.indexOf(',') > 0) {
      
    int firstindex = myString.indexOf(',');
    int secondindex = myString.indexOf(',', firstindex + 1);
    int thirdindex = myString.lastIndexOf(',');

    String var1 = myString.substring(0,firstindex);
    numbRuns = var1.toInt();
    Serial.println(numbRuns);

    String var2 = myString.substring(firstindex+1,secondindex);
    hitLength = 1000*(var2.toInt());
    Serial.println(hitLength);

    String var3 = myString.substring(secondindex+1,myString.length());
    restTime = 1000*(var3.toInt());
    Serial.println(restTime);

    flag4 = true;
    Serial.println("Variables set.");
    delay(1000);
    }
    else{if(myString.substring(0,5) == "clear" | myString.substring(0,5) == "Clear"){flag2 = true; Serial.println("Clearing");}
    else{if(myString.substring(0,4) == "test" | myString.substring(0,4) == "Test"){flag3 = true; Serial.println("Testing 3.."); delay(1000); Serial.println("2.."); delay(1000); Serial.println("1.."); delay(1000);}}}
    
  }
  
  
  
  
  while(flag4 == true) {
  {
    if(Serial.available())
   
    {
      String incoming = Serial.readString();
      if(incoming.substring(0,5) == "start" | incoming.substring(0,5) == "Start")
      {flag1 = true; Serial.println("Running in 3.."); delay(1000); Serial.println("2.."); delay(1000); Serial.println("1.."); delay(1000);}
      
    }
  }

  if(flag1 == true)
  {
    for(int i = 1; i <= numbRuns; i += 1)
    {
    Serial.print("Actuation "); Serial.println(i);
    digitalWrite(relaySol, HIGH); //Turns solenoid on
    digitalWrite(relayFan, HIGH); //Turns fan on
    delay(hitLength); //Delays for 5000ms (5s) with 1s to account for solenoid actuation
    digitalWrite(relaySol, LOW);
    digitalWrite(relayFan, LOW);
      for(int x = 1; x <= restTime / 1000; x +=1)
      {
        delay(1000);
        
        if(Serial.available())
        {
          String incoming2 = Serial.readString();
          Serial.println(incoming2.substring(0,3));
          if(incoming2.substring(0,3) == "end" | incoming2.substring(0,3) == "End"){Serial.println("Run Ended."); (x=restTime/1000); (i = numbRuns);}
        }
        Serial.print(restTime/1000-x);
        Serial.println(" seconds left");
      }

    }
    Serial.println("Run Complete.");
    flag1 = false;
    flag4 = false;
  }
  }
  if(flag2 == true)
  {
    digitalWrite(relaySol, HIGH); //Turns solenoid on
    digitalWrite(relayFan, HIGH); //Turns fan on
    delay(30000);  //Solenoid and fan will remain on for 30 seconds
    
    digitalWrite(relaySol, LOW);
    digitalWrite(relayFan, LOW);
    flag2 = false;
    Serial.println("Clear Complete.");
    flag4 = false;
  }
  if(flag3 == true)
  {
    // Drive motor B (and only motor B) at various speeds, then stop.
    digitalWrite(relaySol, HIGH); //Turns solenoid on
    digitalWrite(relayFan, LOW); //Leaves fan off
    delay(5000);
    digitalWrite(relaySol, LOW); //Leaves solenoid off
    digitalWrite(relayFan, HIGH); //Turns fan on
    delay(5000);
    digitalWrite(relaySol, HIGH); //Turns solenoid on
    digitalWrite(relayFan, HIGH); //Turns fan on
    delay(5000);
    digitalWrite(relaySol, LOW); //Turns solenoid on
    digitalWrite(relayFan, LOW); //Turns fan on
    flag3 = false;
    Serial.println("Test Complete");
    flag4 = false;
  }
  
}
